(ns clj-ml3.bayes
  (:use clj-ml3.data
        [clj-ml classifiers data]))

;; Bayesian classifier using clj-ml

(def bayes-classifier (make-classifier :bayes :naive))

(defn train-bayes-classifier []
  (dataset-set-class fish-dataset 0)
  (classifier-train bayes-classifier fish-dataset))

;; user> (train-bayes-classifier)
;; #<NaiveBayes Naive Bayes Classifier

;;                   Class
;; Attribute        salmon sea-bass
;;                   (0.7)    (0.3)
;; =================================
;; length
;;   mean            2.9791   7.5007
;;   std. dev.       1.9897   1.1264
;;   weight sum        7032     2968
;;   precision            1        1

;; width
;;   mean            6.4822   1.9747
;;   std. dev.        1.706    1.405
;;   weight sum        7032     2968
;;   precision            1        1

;; lightness
;;   mean            2.5146   6.4643
;;   std. dev.       1.7047   1.7204
;;   weight sum        7032     2968
;;   precision            1        1

;; >

;;

;; user> (classifier-classify bayes-classifier sample-fish)
;; :salmon
