(ns clj-ml3.k-means
  (:use clj-ml3.data
        [clj-ml classifiers data]))

;; K-nearest neighbors classifier using clj-ml

(def K1-classifier (make-classifier :lazy :ibk))
(def K10-classifier (make-classifier :lazy :ibk {:num-neighbors 10}))

(defn train-K1-classifier []
  (dataset-set-class fish-dataset 0)
  (classifier-train K1-classifier fish-dataset))

;; user> (train-K1-classifier)
;; #<IBk IB1 instance-based classifier
;; using 1 nearest neighbour(s) for classification
;; >

;;

;; user> (classifier-classify K1-classifier sample-fish)
;; :salmon
