(ns clj-ml4.som
  (:use [enclog nnets training]))

(def som (network (neural-pattern :som) :input 4 :output 2))

(defn train-som [data]
  (let [trainer (trainer :basic-som :network som
                         :training-set data
                         :learning-rate 0.7
                         :neighborhood-fn (neighborhood-F :single))]
    (train trainer Double/NEGATIVE_INFINITY 10 [])))

(defn train-and-run-som []
  (let [input [[-1.0, -1.0, 1.0, 1.0 ]
               [1.0, 1.0, -1.0, -1.0]]
        input-data (data :basic-dataset input nil) ;no ideal data
        SOM        (train-som input-data)
        d1 (data :basic (first input))
        d2 (data :basic (second input))]
    (println "Pattern 1 class:" (.classify SOM d1))
    (println "Pattern 2 class:" (.classify SOM d2))
    SOM))

;; user> (train-and-run-som)
;; Iteration # 1 Error: 2.137686% Target-Error: NaN
;; Iteration # 2 Error: 0.641306% Target-Error: NaN
;; Iteration # 3 Error: 0.192392% Target-Error: NaN
;; ...
;; ...
;; Iteration # 9 Error: 0.000140% Target-Error: NaN
;; Iteration # 10 Error: 0.000042% Target-Error: NaN
;; Pattern 1 class: 1
;; Pattern 2 class: 0
;; #<SOM org.encog.neural.som.SOM@19a0818>
